"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initParticlesJS = void 0;
const initParticlesJS = (engine) => {
    const particlesJS = (tagId, options) => {
        return engine.load({ id: tagId, options });
    };
    particlesJS.load = (tagId, pathConfigJson, callback) => {
        engine
            .load({ id: tagId, url: pathConfigJson })
            .then((container) => {
            if (container) {
                callback(container);
            }
        })
            .catch(() => {
            callback(undefined);
        });
    };
    particlesJS.setOnClickHandler = (callback) => {
        engine.setOnClickHandler(callback);
    };
    const pJSDom = engine.dom();
    return { particlesJS, pJSDom };
};
exports.initParticlesJS = initParticlesJS;
